Index: irc_commands.c
===================================================================
--- irc_commands.c	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
+++ irc_commands.c	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -0,0 +1,622 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2002-2006 Wilmer van der Gaast and others                *
+  \********************************************************************/
+
+/* IRC commands                                                         */
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#define BITLBEE_CORE
+#include "bitlbee.h"
+#include "ipc.h"
+
+static void irc_cmd_pass( irc_t *irc, char **cmd )
+{
+	if( global.conf->auth_pass && strcmp( cmd[1], global.conf->auth_pass ) == 0 )
+	{
+		irc->status = USTATUS_AUTHORIZED;
+		irc_check_login( irc );
+	}
+	else
+	{
+		irc_reply( irc, 464, ":Incorrect password" );
+	}
+}
+
+static void irc_cmd_user( irc_t *irc, char **cmd )
+{
+	irc->user = g_strdup( cmd[1] );
+	irc->realname = g_strdup( cmd[4] );
+	
+	irc_check_login( irc );
+}
+
+static void irc_cmd_nick( irc_t *irc, char **cmd )
+{
+	if( irc->nick )
+	{
+		irc_reply( irc, 438, ":The hand of the deity is upon thee, thy nick may not change" );
+	}
+	/* This is not clean, but for now it'll have to be like this... */
+	else if( ( nick_cmp( cmd[1], irc->mynick ) == 0 ) || ( nick_cmp( cmd[1], NS_NICK ) == 0 ) )
+	{
+		irc_reply( irc, 433, ":This nick is already in use" );
+	}
+	else if( !nick_ok( cmd[1] ) )
+	{
+		/* [SH] Invalid characters. */
+		irc_reply( irc, 432, ":This nick contains invalid characters" );
+	}
+	else
+	{
+		irc->nick = g_strdup( cmd[1] );
+		
+		irc_check_login( irc );
+	}
+}
+
+static void irc_cmd_quit( irc_t *irc, char **cmd )
+{
+	if( cmd[1] && *cmd[1] )
+		irc_abort( irc, 0, "Quit: %s", cmd[1] );
+	else
+		irc_abort( irc, 0, "Leaving..." );
+}
+
+static void irc_cmd_ping( irc_t *irc, char **cmd )
+{
+	irc_write( irc, ":%s PONG %s :%s", irc->myhost, irc->myhost, cmd[1]?cmd[1]:irc->myhost );
+}
+
+static void irc_cmd_oper( irc_t *irc, char **cmd )
+{
+	if( global.conf->oper_pass && strcmp( cmd[2], global.conf->oper_pass ) == 0 )
+	{
+		irc_umode_set( irc, "+o", 1 );
+		irc_reply( irc, 381, ":Password accepted" );
+	}
+	else
+	{
+		irc_reply( irc, 432, ":Incorrect password" );
+	}
+}
+
+static void irc_cmd_mode( irc_t *irc, char **cmd )
+{
+	if( *cmd[1] == '#' || *cmd[1] == '&' )
+	{
+		if( cmd[2] )
+		{
+			if( *cmd[2] == '+' || *cmd[2] == '-' )
+				irc_reply( irc, 477, "%s :Can't change channel modes", cmd[1] );
+			else if( *cmd[2] == 'b' )
+				irc_reply( irc, 368, "%s :No bans possible", cmd[1] );
+		}
+		else
+			irc_reply( irc, 324, "%s +%s", cmd[1], CMODE );
+	}
+	else
+	{
+		if( nick_cmp( cmd[1], irc->nick ) == 0 )
+		{
+			if( cmd[2] )
+				irc_umode_set( irc, cmd[2], 0 );
+		}
+		else
+			irc_reply( irc, 502, ":Don't touch their modes" );
+	}
+}
+
+static void irc_cmd_names( irc_t *irc, char **cmd )
+{
+	irc_names( irc, cmd[1]?cmd[1]:irc->channel );
+}
+
+static void irc_cmd_part( irc_t *irc, char **cmd )
+{
+	struct conversation *c;
+	
+	if( g_strcasecmp( cmd[1], irc->channel ) == 0 )
+	{
+		user_t *u = user_find( irc, irc->nick );
+		
+		/* Not allowed to leave control channel */
+		irc_part( irc, u, irc->channel );
+		irc_join( irc, u, irc->channel );
+	}
+	else if( ( c = conv_findchannel( cmd[1] ) ) )
+	{
+		user_t *u = user_find( irc, irc->nick );
+		
+		irc_part( irc, u, c->channel );
+		
+		if( c->gc && c->gc->prpl )
+		{
+			c->joined = 0;
+			c->gc->prpl->chat_leave( c->gc, c->id );
+		}
+	}
+	else
+	{
+		irc_reply( irc, 403, "%s :No such channel", cmd[1] );
+	}
+}
+
+static void irc_cmd_join( irc_t *irc, char **cmd )
+{
+	if( g_strcasecmp( cmd[1], irc->channel ) == 0 )
+		; /* Dude, you're already there...
+		     RFC doesn't have any reply for that though? */
+	else if( cmd[1] )
+	{
+		if( ( cmd[1][0] == '#' || cmd[1][0] == '&' ) && cmd[1][1] )
+		{
+			user_t *u = user_find( irc, cmd[1] + 1 );
+			
+			if( u && u->gc && u->gc->prpl && u->gc->prpl->chat_open )
+			{
+				irc_reply( irc, 403, "%s :Initializing groupchat in a different channel", cmd[1] );
+				
+				if( !u->gc->prpl->chat_open( u->gc, u->handle ) )
+				{
+					irc_usermsg( irc, "Could not open a groupchat with %s, maybe you don't have a connection to him/her yet?", u->nick );
+				}
+			}
+			else if( u )
+			{
+				irc_reply( irc, 403, "%s :Groupchats are not possible with %s", cmd[1], cmd[1]+1 );
+			}
+			else
+			{
+				irc_reply( irc, 403, "%s :No such nick", cmd[1] );
+			}
+		}
+		else
+		{
+			irc_reply( irc, 403, "%s :No such channel", cmd[1] );
+		}
+	}
+}
+
+static void irc_cmd_invite( irc_t *irc, char **cmd )
+{
+	char *nick = cmd[1], *channel = cmd[2];
+	struct conversation *c = conv_findchannel( channel );
+	user_t *u = user_find( irc, nick );
+	
+	if( u && c && ( u->gc == c->gc ) )
+		if( c->gc && c->gc->prpl && c->gc->prpl->chat_invite )
+		{
+			c->gc->prpl->chat_invite( c->gc, c->id, "", u->handle );
+			irc_reply( irc, 341, "%s %s", nick, channel );
+			return;
+		}
+	
+	irc_reply( irc, 482, "%s :Invite impossible; User/Channel non-existent or incompatible", channel );
+}
+
+static void irc_cmd_privmsg( irc_t *irc, char **cmd )
+{
+	if ( !cmd[2] ) 
+	{
+		irc_reply( irc, 412, ":No text to send" );
+	}
+	else if ( irc->nick && g_strcasecmp( cmd[1], irc->nick ) == 0 ) 
+	{
+		irc_write( irc, ":%s!%s@%s %s %s :%s", irc->nick, irc->user, irc->host, cmd[0], cmd[1], cmd[2] ); 
+	}
+	else 
+	{
+		if( g_strcasecmp( cmd[1], irc->channel ) == 0 )
+		{
+			unsigned int i;
+			char *t = set_getstr( irc, "default_target" );
+			
+			if( g_strcasecmp( t, "last" ) == 0 && irc->last_target )
+				cmd[1] = irc->last_target;
+			else if( g_strcasecmp( t, "root" ) == 0 )
+				cmd[1] = irc->mynick;
+			
+			for( i = 0; i < strlen( cmd[2] ); i ++ )
+			{
+				if( cmd[2][i] == ' ' ) break;
+				if( cmd[2][i] == ':' || cmd[2][i] == ',' )
+				{
+					cmd[1] = cmd[2];
+					cmd[2] += i;
+					*cmd[2] = 0;
+					while( *(++cmd[2]) == ' ' );
+					break;
+				}
+			}
+			
+			irc->is_private = 0;
+			
+			if( cmd[1] != irc->last_target )
+			{
+				if( irc->last_target )
+					g_free( irc->last_target );
+				irc->last_target = g_strdup( cmd[1] );
+			}
+		}
+		else
+		{
+			irc->is_private = 1;
+		}
+		irc_send( irc, cmd[1], cmd[2], ( g_strcasecmp( cmd[0], "NOTICE" ) == 0 ) ? IM_FLAG_AWAY : 0 );
+	}
+}
+
+static void irc_cmd_who( irc_t *irc, char **cmd )
+{
+	char *channel = cmd[1];
+	user_t *u = irc->users;
+	struct conversation *c;
+	GList *l;
+	
+	if( !channel || *channel == '0' || *channel == '*' || !*channel )
+		while( u )
+		{
+			irc_reply( irc, 352, "%s %s %s %s %s %c :0 %s", u->online ? irc->channel : "*", u->user, u->host, irc->myhost, u->nick, u->online ? ( u->away ? 'G' : 'H' ) : 'G', u->realname );
+			u = u->next;
+		}
+	else if( g_strcasecmp( channel, irc->channel ) == 0 )
+		while( u )
+		{
+			if( u->online )
+				irc_reply( irc, 352, "%s %s %s %s %s %c :0 %s", channel, u->user, u->host, irc->myhost, u->nick, u->away ? 'G' : 'H', u->realname );
+			u = u->next;
+		}
+	else if( ( c = conv_findchannel( channel ) ) )
+		for( l = c->in_room; l; l = l->next )
+		{
+			if( ( u = user_findhandle( c->gc, l->data ) ) )
+				irc_reply( irc, 352, "%s %s %s %s %s %c :0 %s", channel, u->user, u->host, irc->myhost, u->nick, u->away ? 'G' : 'H', u->realname );
+		}
+	else if( ( u = user_find( irc, channel ) ) )
+		irc_reply( irc, 352, "%s %s %s %s %s %c :0 %s", channel, u->user, u->host, irc->myhost, u->nick, u->online ? ( u->away ? 'G' : 'H' ) : 'G', u->realname );
+	
+	irc_reply( irc, 315, "%s :End of /WHO list", channel?channel:"**" );
+}
+
+static void irc_cmd_userhost( irc_t *irc, char **cmd )
+{
+	user_t *u;
+	int i;
+	
+	/* [TV] Usable USERHOST-implementation according to
+		RFC1459. Without this, mIRC shows an error
+		while connecting, and the used way of rejecting
+		breaks standards.
+	*/
+	
+	for( i = 1; cmd[i]; i ++ )
+		if( ( u = user_find( irc, cmd[i] ) ) )
+		{
+			if( u->online && u->away )
+				irc_reply( irc, 302, ":%s=-%s@%s", u->nick, u->user, u->host );
+			else
+				irc_reply( irc, 302, ":%s=+%s@%s", u->nick, u->user, u->host );
+		}
+}
+
+static void irc_cmd_ison( irc_t *irc, char **cmd )
+{
+	user_t *u;
+	char buff[IRC_MAX_LINE];
+	int lenleft, i;
+	
+	buff[0] = '\0';
+	
+	/* [SH] Leave room for : and \0 */
+	lenleft = IRC_MAX_LINE - 2;
+	
+	for( i = 1; cmd[i]; i ++ )
+	{
+		if( ( u = user_find( irc, cmd[i] ) ) && u->online )
+		{
+			/* [SH] Make sure we don't use too much buffer space. */
+			lenleft -= strlen( u->nick ) + 1;
+			
+			if( lenleft < 0 )
+			{
+				break;
+			}
+			
+			/* [SH] Add the nick to the buffer. Note
+			 * that an extra space is always added. Even
+			 * if it's the last nick in the list. Who
+			 * cares?
+			 */
+			
+			strcat( buff, u->nick );
+			strcat( buff, " " );
+		}
+	}
+	
+	/* [WvG] Well, maybe someone cares, so why not remove it? */
+	if( strlen( buff ) > 0 )
+		buff[strlen(buff)-1] = '\0';
+	
+	irc_reply( irc, 303, ":%s", buff );
+}
+
+static void irc_cmd_watch( irc_t *irc, char **cmd )
+{
+	int i;
+	
+	/* Obviously we could also mark a user structure as being
+	   watched, but what if the WATCH command is sent right
+	   after connecting? The user won't exist yet then... */
+	for( i = 1; cmd[i]; i ++ )
+	{
+		char *nick;
+		user_t *u;
+		
+		if( !cmd[i][0] || !cmd[i][1] )
+			break;
+		
+		nick = g_strdup( cmd[i] + 1 );
+		nick_lc( nick );
+		
+		u = user_find( irc, nick );
+		
+		if( cmd[i][0] == '+' )
+		{
+			if( !g_hash_table_lookup( irc->watches, nick ) )
+				g_hash_table_insert( irc->watches, nick, nick );
+			
+			if( u && u->online )
+				irc_reply( irc, 604, "%s %s %s %d :%s", u->nick, u->user, u->host, time( NULL ), "is online" );
+			else
+				irc_reply( irc, 605, "%s %s %s %d :%s", nick, "*", "*", time( NULL ), "is offline" );
+		}
+		else if( cmd[i][0] == '-' )
+		{
+			gpointer okey, ovalue;
+			
+			if( g_hash_table_lookup_extended( irc->watches, nick, &okey, &ovalue ) )
+			{
+				g_free( okey );
+				g_hash_table_remove( irc->watches, okey );
+				
+				irc_reply( irc, 602, "%s %s %s %d :%s", nick, "*", "*", 0, "Stopped watching" );
+			}
+		}
+	}
+}
+
+static void irc_cmd_topic( irc_t *irc, char **cmd )
+{
+	if( cmd[2] )
+		irc_reply( irc, 482, "%s :Cannot change topic", cmd[1] );
+	else
+		irc_topic( irc, cmd[1] );
+}
+
+static void irc_cmd_away( irc_t *irc, char **cmd )
+{
+	user_t *u = user_find( irc, irc->nick );
+	char *away = cmd[1];
+	account_t *a;
+	
+	if( !u ) return;
+	
+	if( away && *away )
+	{
+		int i, j;
+		
+		/* Copy away string, but skip control chars. Mainly because
+		   Jabber really doesn't like them. */
+		u->away = g_malloc( strlen( away ) + 1 );
+		for( i = j = 0; away[i]; i ++ )
+			if( ( u->away[j] = away[i] ) >= ' ' )
+				j ++;
+		u->away[j] = 0;
+		
+		irc_reply( irc, 306, ":You're now away: %s", u->away );
+		/* irc_umode_set( irc, irc->myhost, "+a" ); */
+	}
+	else
+	{
+		if( u->away ) g_free( u->away );
+		u->away = NULL;
+		/* irc_umode_set( irc, irc->myhost, "-a" ); */
+		irc_reply( irc, 305, ":Welcome back" );
+	}
+	
+	for( a = irc->accounts; a; a = a->next )
+	{
+		struct gaim_connection *gc = a->gc;
+		
+		if( gc && gc->flags & OPT_LOGGED_IN )
+			proto_away( gc, u->away );
+	}
+}
+
+static void irc_cmd_whois( irc_t *irc, char **cmd )
+{
+	char *nick = cmd[1];
+	user_t *u = user_find( irc, nick );
+	
+	if( u )
+	{
+		irc_reply( irc, 311, "%s %s %s * :%s", u->nick, u->user, u->host, u->realname );
+		
+		if( u->gc )
+			irc_reply( irc, 312, "%s %s.%s :%s network", u->nick, u->gc->user->username,
+			           *u->gc->user->proto_opt[0] ? u->gc->user->proto_opt[0] : "", u->gc->prpl->name );
+		else
+			irc_reply( irc, 312, "%s %s :%s", u->nick, irc->myhost, IRCD_INFO );
+		
+		if( !u->online )
+			irc_reply( irc, 301, "%s :%s", u->nick, "User is offline" );
+		else if( u->away )
+			irc_reply( irc, 301, "%s :%s", u->nick, u->away );
+		
+		irc_reply( irc, 318, "%s :End of /WHOIS list", nick );
+	}
+	else
+	{
+		irc_reply( irc, 401, "%s :Nick does not exist", nick );
+	}
+}
+
+static void irc_cmd_whowas( irc_t *irc, char **cmd )
+{
+	/* For some reason irssi tries a whowas when whois fails. We can
+	   ignore this, but then the user never gets a "user not found"
+	   message from irssi which is a bit annoying. So just respond
+	   with not-found and irssi users will get better error messages */
+	
+	irc_reply( irc, 406, "%s :Nick does not exist", cmd[1] );
+	irc_reply( irc, 369, "%s :End of WHOWAS", cmd[1] );
+}
+
+static void irc_cmd_nickserv( irc_t *irc, char **cmd )
+{
+	/* [SH] This aliases the NickServ command to PRIVMSG root */
+	/* [TV] This aliases the NS command to PRIVMSG root as well */
+	root_command( irc, cmd + 1 );
+}
+
+static void irc_cmd_motd( irc_t *irc, char **cmd )
+{
+	irc_motd( irc );
+}
+
+static void irc_cmd_pong( irc_t *irc, char **cmd )
+{
+	/* We could check the value we get back from the user, but in
+	   fact we don't care, we're just happy he's still alive. */
+	irc->last_pong = gettime();
+	irc->pinging = 0;
+}
+
+static void irc_cmd_completions( irc_t *irc, char **cmd )
+{
+	user_t *u = user_find( irc, irc->mynick );
+	help_t *h;
+	set_t *s;
+	int i;
+	
+	irc_privmsg( irc, u, "NOTICE", irc->nick, "COMPLETIONS ", "OK" );
+	
+	for( i = 0; commands[i].command; i ++ )
+		irc_privmsg( irc, u, "NOTICE", irc->nick, "COMPLETIONS ", commands[i].command );
+	
+	for( h = global.help; h; h = h->next )
+		irc_privmsg( irc, u, "NOTICE", irc->nick, "COMPLETIONS help ", h->string );
+	
+	for( s = irc->set; s; s = s->next )
+		irc_privmsg( irc, u, "NOTICE", irc->nick, "COMPLETIONS set ", s->key );
+	
+	irc_privmsg( irc, u, "NOTICE", irc->nick, "COMPLETIONS ", "END" );
+}
+
+static void irc_cmd_rehash( irc_t *irc, char **cmd )
+{
+	if( global.conf->runmode == RUNMODE_INETD )
+		ipc_master_cmd_rehash( NULL, NULL );
+	else
+		ipc_to_master( cmd );
+	
+	irc_reply( irc, 382, "%s :Rehashing", CONF_FILE );
+}
+
+static const command_t irc_commands[] = {
+	{ "pass",        1, irc_cmd_pass,        IRC_CMD_PRE_LOGIN },
+	{ "user",        4, irc_cmd_user,        IRC_CMD_PRE_LOGIN },
+	{ "nick",        1, irc_cmd_nick,        0 },
+	{ "quit",        0, irc_cmd_quit,        0 },
+	{ "ping",        0, irc_cmd_ping,        0 },
+	{ "oper",        2, irc_cmd_oper,        IRC_CMD_LOGGED_IN },
+	{ "mode",        1, irc_cmd_mode,        IRC_CMD_LOGGED_IN },
+	{ "names",       0, irc_cmd_names,       IRC_CMD_LOGGED_IN },
+	{ "part",        1, irc_cmd_part,        IRC_CMD_LOGGED_IN },
+	{ "join",        1, irc_cmd_join,        IRC_CMD_LOGGED_IN },
+	{ "invite",      2, irc_cmd_invite,      IRC_CMD_LOGGED_IN },
+	{ "privmsg",     1, irc_cmd_privmsg,     IRC_CMD_LOGGED_IN },
+	{ "notice",      1, irc_cmd_privmsg,     IRC_CMD_LOGGED_IN },
+	{ "who",         0, irc_cmd_who,         IRC_CMD_LOGGED_IN },
+	{ "userhost",    1, irc_cmd_userhost,    IRC_CMD_LOGGED_IN },
+	{ "ison",        1, irc_cmd_ison,        IRC_CMD_LOGGED_IN },
+	{ "watch",       1, irc_cmd_watch,       IRC_CMD_LOGGED_IN },
+	{ "topic",       1, irc_cmd_topic,       IRC_CMD_LOGGED_IN },
+	{ "away",        0, irc_cmd_away,        IRC_CMD_LOGGED_IN },
+	{ "whois",       1, irc_cmd_whois,       IRC_CMD_LOGGED_IN },
+	{ "whowas",      1, irc_cmd_whowas,      IRC_CMD_LOGGED_IN },
+	{ "nickserv",    1, irc_cmd_nickserv,    IRC_CMD_LOGGED_IN },
+	{ "ns",          1, irc_cmd_nickserv,    IRC_CMD_LOGGED_IN },
+	{ "motd",        0, irc_cmd_motd,        IRC_CMD_LOGGED_IN },
+	{ "pong",        0, irc_cmd_pong,        IRC_CMD_LOGGED_IN },
+	{ "completions", 0, irc_cmd_completions, IRC_CMD_LOGGED_IN },
+	{ "die",         0, NULL,                IRC_CMD_OPER_ONLY | IRC_CMD_TO_MASTER },
+	{ "wallops",     1, NULL,                IRC_CMD_OPER_ONLY | IRC_CMD_TO_MASTER },
+	{ "lilo",        1, NULL,                IRC_CMD_OPER_ONLY | IRC_CMD_TO_MASTER },
+	{ "rehash",      0, irc_cmd_rehash,      IRC_CMD_OPER_ONLY },
+	{ "restart",     0, NULL,                IRC_CMD_OPER_ONLY | IRC_CMD_TO_MASTER },
+	{ "kill",        2, NULL,                IRC_CMD_OPER_ONLY | IRC_CMD_TO_MASTER },
+	{ NULL }
+};
+
+void irc_exec( irc_t *irc, char *cmd[] )
+{	
+	int i, n_arg;
+	
+	if( !cmd[0] )
+		return;
+	
+	for( i = 0; irc_commands[i].command; i++ )
+		if( g_strcasecmp( irc_commands[i].command, cmd[0] ) == 0 )
+		{
+			/* There should be no typo in the next line: */
+			for( n_arg = 0; cmd[n_arg]; n_arg ++ ); n_arg --;
+			
+			if( irc_commands[i].flags & IRC_CMD_PRE_LOGIN && irc->status >= USTATUS_LOGGED_IN )
+			{
+				irc_reply( irc, 462, ":Only allowed before logging in" );
+			}
+			else if( irc_commands[i].flags & IRC_CMD_LOGGED_IN && irc->status < USTATUS_LOGGED_IN )
+			{
+				irc_reply( irc, 451, ":Register first" );
+			}
+			else if( irc_commands[i].flags & IRC_CMD_OPER_ONLY && !strchr( irc->umode, 'o' ) )
+			{
+				irc_reply( irc, 481, ":Permission denied - You're not an IRC operator" );
+			}
+			else if( n_arg < irc_commands[i].required_parameters )
+			{
+				irc_reply( irc, 461, "%s :Need more parameters", cmd[0] );
+			}
+			else if( irc_commands[i].flags & IRC_CMD_TO_MASTER )
+			{
+				/* IPC doesn't make sense in inetd mode,
+				    but the function will catch that. */
+				ipc_to_master( cmd );
+			}
+			else
+			{
+				irc_commands[i].execute( irc, cmd );
+			}
+			
+			break;
+		}
+}
Index: protocols/jabber/jabber.c
===================================================================
--- protocols/jabber/jabber.c	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
+++ protocols/jabber/jabber.c	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -413,5 +413,5 @@
 		if (jd->die)
 			signoff(GJ_GC(gjc));
-	} else if (len < 0 || errno != EAGAIN) {
+	} else if (len == 0 || (len < 0 && (!sockerr_again() || gjc->ssl))) {
 		STATE_EVT(JCONN_STATE_OFF)
 	}
Index: protocols/msn/msn.c
===================================================================
--- protocols/msn/msn.c	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
+++ protocols/msn/msn.c	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -84,4 +84,6 @@
 		{
 			m = l->data;
+		
+			serv_got_crap( gc, "Warning: Closing down MSN connection with unsent message to %s, you'll have to resend it.", m->who );
 			g_free( m->who );
 			g_free( m->text );
@@ -89,6 +91,4 @@
 		}
 		g_slist_free( md->msgq );
-		
-		serv_got_crap( gc, "Warning: Closing down MSN connection with unsent message(s), you'll have to resend them." );
 	}
 	
Index: protocols/msn/sb.c
===================================================================
--- protocols/msn/sb.c	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
+++ protocols/msn/sb.c	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -213,4 +213,5 @@
 		{
 			m = l->data;
+
 			g_free( m->who );
 			g_free( m->text );
@@ -219,5 +220,7 @@
 		g_slist_free( sb->msgq );
 		
-		serv_got_crap( gc, "Warning: Closing down MSN switchboard connection with unsent message(s), you'll have to resend them." );
+		serv_got_crap( gc, "Warning: Closing down MSN switchboard connection with "
+		                   "unsent message to %s, you'll have to resend it.",
+		                   m->who ? m->who : "(unknown)" );
 	}
 	
Index: protocols/oscar/oscar.c
===================================================================
--- protocols/oscar/oscar.c	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
+++ protocols/oscar/oscar.c	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -608,4 +608,5 @@
 		return;
 	}
+	/* [WvG] Wheeeee! Who needs error checking anyway? ;-) */
 	read(pos->fd, m, 16);
 	m[16] = '\0';
Index: protocols/oscar/rxqueue.c
===================================================================
--- protocols/oscar/rxqueue.c	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
+++ protocols/oscar/rxqueue.c	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -353,6 +353,13 @@
 		return -1; /* its a aim_conn_close()'d connection */
 
-	if (conn->fd < 3)  /* can happen when people abuse the interface */
+	/* KIDS, THIS IS WHAT HAPPENS IF YOU USE CODE WRITTEN FOR GUIS IN A DAEMON!
+	   
+	   And wouldn't it make sense to return something that prevents this function
+	   from being called again IMMEDIATELY (and making the program suck up all
+	   CPU time)?...
+	   
+	if (conn->fd < 3)
 		return 0;
+	*/
 
 	if (conn->status & AIM_CONN_STATUS_INPROGRESS)
Index: protocols/oscar/service.c
===================================================================
--- protocols/oscar/service.c	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
+++ protocols/oscar/service.c	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -736,6 +736,4 @@
 
 	tlvlen = aim_addtlvtochain32(&tl, 0x0006, data);
-
-	printf("%d\n", tlvlen);
 
 	if (!(fr = aim_tx_new(sess, conn, AIM_FRAMETYPE_FLAP, 0x02, 10 + 8)))
Index: protocols/ssl_openssl.c
===================================================================
--- protocols/ssl_openssl.c	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
+++ protocols/ssl_openssl.c	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -5,5 +5,5 @@
   \********************************************************************/
 
-/* SSL module - GnuTLS version                                          */
+/* SSL module - OpenTLS version                                          */
 
 /*
@@ -41,11 +41,9 @@
 struct scd
 {
-	ssl_input_function func;
+	SslInputFunction func;
 	gpointer data;
 	int fd;
 	gboolean established;
 	
-	int inpa;
-	int lasterr;		/* Necessary for SSL_get_error */
 	SSL *ssl;
 	SSL_CTX *ssl_ctx;
@@ -56,5 +54,5 @@
 
 
-void *ssl_connect( char *host, int port, ssl_input_function func, gpointer data )
+void *ssl_connect( char *host, int port, SslInputFunction func, gpointer data )
 {
 	struct scd *conn = g_new0( struct scd, 1 );
@@ -95,6 +93,4 @@
 }
 
-static void ssl_handshake( gpointer data, gint source, GaimInputCondition cond );
-
 static void ssl_connected( gpointer data, gint source, GaimInputCondition cond )
 {
@@ -102,36 +98,12 @@
 	
 	if( source == -1 )
-		return ssl_handshake( data, -1, cond );
+		goto ssl_connected_failure;
 	
-	/* Make it non-blocking at least during the handshake... */
-	sock_make_nonblocking( conn->fd );
 	SSL_set_fd( conn->ssl, conn->fd );
 	
-	return ssl_handshake( data, source, cond );
-}	
-
-static void ssl_handshake( gpointer data, gint source, GaimInputCondition cond )
-{
-	struct scd *conn = data;
-	int st;
-	
-	if( conn->inpa != -1 )
-	{
-		gaim_input_remove( conn->inpa );
-		conn->inpa = -1;
-	}
-	
-	if( ( st = SSL_connect( conn->ssl ) ) < 0 )
-	{
-		conn->lasterr = SSL_get_error( conn->ssl, st );
-		if( conn->lasterr != SSL_ERROR_WANT_READ && conn->lasterr != SSL_ERROR_WANT_WRITE )
-			goto ssl_connected_failure;
-		
-		conn->inpa = gaim_input_add( conn->fd, ssl_getdirection( conn ), ssl_handshake, data );
-		return;
-	}
+	if( SSL_connect( conn->ssl ) < 0 )
+		goto ssl_connected_failure;
 	
 	conn->established = TRUE;
-	sock_make_blocking( conn->fd );		/* For now... */
 	conn->func( conn->data, conn, cond );
 	return;
@@ -155,46 +127,16 @@
 int ssl_read( void *conn, char *buf, int len )
 {
-	int st;
+	if( !((struct scd*)conn)->established )
+		return( 0 );
 	
-	if( !((struct scd*)conn)->established )
-	{
-		ssl_errno = SSL_NOHANDSHAKE;
-		return -1;
-	}
-	
-	st = SSL_read( ((struct scd*)conn)->ssl, buf, len );
-	
-	ssl_errno = SSL_OK;
-	if( st <= 0 )
-	{
-		((struct scd*)conn)->lasterr = SSL_get_error( ((struct scd*)conn)->ssl, st );
-		if( ((struct scd*)conn)->lasterr == SSL_ERROR_WANT_READ || ((struct scd*)conn)->lasterr == SSL_ERROR_WANT_WRITE )
-			ssl_errno = SSL_AGAIN;
-	}
-	
-	return st;
+	return( SSL_read( ((struct scd*)conn)->ssl, buf, len ) );
 }
 
 int ssl_write( void *conn, const char *buf, int len )
 {
-	int st;
+	if( !((struct scd*)conn)->established )
+		return( 0 );
 	
-	if( !((struct scd*)conn)->established )
-	{
-		ssl_errno = SSL_NOHANDSHAKE;
-		return -1;
-	}
-	
-	st = SSL_write( ((struct scd*)conn)->ssl, buf, len );
-	
-	ssl_errno = SSL_OK;
-	if( st <= 0 )
-	{
-		((struct scd*)conn)->lasterr = SSL_get_error( ((struct scd*)conn)->ssl, st );
-		if( ((struct scd*)conn)->lasterr == SSL_ERROR_WANT_READ || ((struct scd*)conn)->lasterr == SSL_ERROR_WANT_WRITE )
-			ssl_errno = SSL_AGAIN;
-	}
-	
-	return st;
+	return( SSL_write( ((struct scd*)conn)->ssl, buf, len ) );
 }
 
@@ -202,7 +144,4 @@
 {
 	struct scd *conn = conn_;
-	
-	if( conn->inpa != -1 )
-		gaim_input_remove( conn->inpa );
 	
 	if( conn->established )
@@ -220,7 +159,2 @@
 	return( ((struct scd*)conn)->fd );
 }
-
-GaimInputCondition ssl_getdirection( void *conn )
-{
-	return( ((struct scd*)conn)->lasterr == SSL_ERROR_WANT_WRITE ? GAIM_INPUT_WRITE : GAIM_INPUT_READ );
-}
Index: protocols/yahoo/Makefile
===================================================================
--- protocols/yahoo/Makefile	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
+++ protocols/yahoo/Makefile	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -10,5 +10,5 @@
 
 # [SH] Program variables
-objects = yahoo.o crypt.o libyahoo2.o yahoo_fn.o yahoo_httplib.o yahoo_list.o yahoo_util.o
+objects = yahoo.o crypt.o libyahoo2.o yahoo_fn.o yahoo_httplib.o yahoo_util.o
 
 CFLAGS += -Wall -DSTDC_HEADERS -DHAVE_STRING_H -DHAVE_STRCHR -DHAVE_MEMCPY -DHAVE_GLIB
Index: protocols/yahoo/yahoo.c
===================================================================
--- protocols/yahoo/yahoo.c	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
+++ protocols/yahoo/yahoo.c	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -189,16 +189,16 @@
 {
 	struct byahoo_data *yd = (struct byahoo_data *) gc->proto_data;
-
+	
 	gc->away = NULL;
-
-	if (msg)
+	
+	if( msg )
 	{
 		yd->current_status = YAHOO_STATUS_CUSTOM;
 		gc->away = "";
 	}
-	else if (state)
+	if( state )
 	{
 		gc->away = "";
-		if( g_strcasecmp(state, "Available" ) == 0 )
+		if( g_strcasecmp( state, "Available" ) == 0 )
 		{
 			yd->current_status = YAHOO_STATUS_AVAILABLE;
@@ -235,10 +235,13 @@
 		}
 	}
-	else if ( gc->is_idle )
+	else if( gc->is_idle )
 		yd->current_status = YAHOO_STATUS_IDLE;
 	else
 		yd->current_status = YAHOO_STATUS_AVAILABLE;
 	
-	yahoo_set_away( yd->y2_id, yd->current_status, msg, gc->away != NULL );
+	if( yd->current_status == YAHOO_STATUS_INVISIBLE )
+		yahoo_set_away( yd->y2_id, yd->current_status, NULL, gc->away != NULL );
+	else
+		yahoo_set_away( yd->y2_id, yd->current_status, msg, gc->away != NULL );
 }
 
Index: protocols/yahoo/yahoo_list.h
===================================================================
--- protocols/yahoo/yahoo_list.h	(revision 8e419cb4f86679636b2d96618e1bec4853636c11)
+++ protocols/yahoo/yahoo_list.h	(revision a4dc9f77de03eb46ecabed02dbd1b678319cf11d)
@@ -21,54 +21,28 @@
  */
 
-/*
- * This is a replacement for the GList.  It only provides functions that 
- * we use in Ayttm.  Thanks to Meredyyd from everybuddy dev for doing 
- * most of it.
- */
-
 #ifndef __YLIST_H__
 #define __YLIST_H__
 
-#ifdef __cplusplus
-extern "C" {
+/* GLib has linked list already, so I don't see why libyahoo2 has to copy this... */
+
+typedef GList YList;
+
+#define y_list_append g_list_append
+#define y_list_concat g_list_concat
+#define y_list_copy g_list_copy
+#define y_list_empty g_list_empty
+#define y_list_find g_list_find
+#define y_list_find_custom g_list_find_custom
+#define y_list_foreach g_list_foreach
+#define y_list_free g_list_free
+#define y_list_free_1 g_list_free_1
+#define y_list_insert_sorted g_list_insert_sorted
+#define y_list_length g_list_length
+#define y_list_next g_list_next
+#define y_list_nth g_list_nth
+#define y_list_prepend g_list_prepend
+#define y_list_remove g_list_remove
+#define y_list_remove_link g_list_remove_link
+#define y_list_singleton g_list_singleton
+
 #endif
-
-typedef struct _YList {
-	struct _YList *next;
-	struct _YList *prev;
-	void *data;
-} YList;
-
-typedef int (*YListCompFunc) (const void *, const void *);
-typedef void (*YListFunc) (void *, void *);
-
-YList *y_list_append(YList * list, void *data);
-YList *y_list_prepend(YList * list, void *data);
-YList *y_list_remove_link(YList * list, const YList * link);
-YList *y_list_remove(YList * list, void *data);
-
-YList *y_list_insert_sorted(YList * list, void * data, YListCompFunc comp);
-
-YList *y_list_copy(YList * list);
-
-YList *y_list_concat(YList * list, YList * add);
-
-YList *y_list_find(YList * list, const void *data);
-YList *y_list_find_custom(YList * list, const void *data, YListCompFunc comp);
-
-YList *y_list_nth(YList * list, int n);
-
-void y_list_foreach(YList * list, YListFunc fn, void *user_data);
-
-void y_list_free_1(YList * list);
-void y_list_free(YList * list);
-int  y_list_length(const YList * list);
-int  y_list_empty(const YList * list);
-int  y_list_singleton(const YList * list);
-
-#define y_list_next(list)	list->next
-
-#ifdef __cplusplus
-}
-#endif
-#endif
